-- By Angelol @ Blackmoore(eu) --



-- Input Functions --

ClassCooldownAnnouncer.Slash = function(msg)

		ClassCooldownAnnouncer.RegisterEvents(not ClassCooldownAnnouncer.enabled);
		
	end	

SLASH_ClassCooldownAnnouncer1 = "/classcooldownannouncer";
SLASH_ClassCooldownAnnouncer2 = "/cca";
SlashCmdList["ClassCooldownAnnouncer"] = ClassCooldownAnnouncer.Slash;
SlashCmdList["cca"] = ClassCooldownAnnouncer.Slash;


-- Event Functions --

ClassCooldownAnnouncer.OnEvent = function(...)
	local args = {...}
	local event = args[2];

	

	-- Player is casting a spell and is not oor/oom
	if (event=="UNIT_SPELLCAST_SENT" and args[3]=="player") then
		local spellName, spellTarget = args[4], args[6];
		
		if (ClassCooldownAnnouncer.Announces[spellName]) then
			ClassCooldownAnnouncer.waitingForSuccess = true;
			ClassCooldownAnnouncer.spellName = spellName;
			ClassCooldownAnnouncer.spellTarget = spellTarget;
			ClassCooldownAnnouncer.spellFail = nil;
		end

	-- Spellcast -waiting for success- succeded/started
	elseif ((event=="UNIT_SPELLCAST_START" or event=="UNIT_SPELLCAST_SUCCEEDED") and args[3]=="player" and ClassCooldownAnnouncer.waitingForSuccess) then
		local spellName = args[4] or UnitCastingInfo("player"); --args[4] is nil for Healing Touch
		
		if (ClassCooldownAnnouncer.Announces[spellName]) then
			ClassCooldownAnnouncer.Announces[spellName]("success", ClassCooldownAnnouncer.spellTarget);
			--ClassCooldownAnnouncer.Announce(spellName, "Success", ClassCooldownAnnouncer.spellTarget);
			ClassCooldownAnnouncer.waitingForSuccess = false;
			ClassCooldownAnnouncer.spellName = nil;
			ClassCooldownAnnouncer.spellTarget = nil;
			ClassCooldownAnnouncer.spellFail = nil;
		end

	-- A spell produced an error-message
	elseif (event=="CHAT_MSG_SPELL_FAILED_LOCALPLAYER") then
		local errorText = args[3];
		
		ClassCooldownAnnouncer.spellFail = nil;

		local found, _, errorSpell, errorFail = string.find (errorText, "^"..ClassCooldownAnnouncer.FAILEDSPELL.." (.*): (.-)$");
		if (found and ClassCooldownAnnouncer.Announces[errorSpell]) then

			
			ClassCooldownAnnouncer.spellName = errorSpell;
			
			if (errorFail == ClassCooldownAnnouncer.FAILEDSPELL_OOR) then
				ClassCooldownAnnouncer.spellFail = "oor";
			elseif (errorFail == ClassCooldownAnnouncer.FAILEDSPELL_LOS) then
				ClassCooldownAnnouncer.spellFail = "los";
			end
		end
	
	-- A spell -waiting for success- failed
	elseif (event=="UNIT_SPELLCAST_FAILED" and args[3]=="player" and ClassCooldownAnnouncer.waitingForSuccess and ClassCooldownAnnouncer.spellFail) then
		-- What if we dont have an error? 
		-- Invalid target errors, for example. spellFail check is fixing it.
		
		if (ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.spellName]) then
			ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.spellName](ClassCooldownAnnouncer.spellFail, ClassCooldownAnnouncer.spellTarget);
		end

		ClassCooldownAnnouncer.waitingForSuccess = false;
		ClassCooldownAnnouncer.spellName = nil;
		ClassCooldownAnnouncer.spellTarget = nil;
		ClassCooldownAnnouncer.spellFail = nil;

	end
	
	
	
end

ClassCooldownAnnouncer.frame = CreateFrame("Frame");
ClassCooldownAnnouncer.frame:SetScript("OnEvent", ClassCooldownAnnouncer.OnEvent);





-- Hooking Functions --

ClassCooldownAnnouncer.SpellByName = function(spellName, spellTarget)

	if (ClassCooldownAnnouncer.spellFail and not ClassCooldownAnnouncer.waitingForSuccess) then

		
		local spellName = string.lower(spellName);
		
		local spellTargetName = UnitName("target");
		if (spellTarget) then spellTargetName = UnitName(spellTarget); end
		
		local cooldown = 1;
		if (ClassCooldownAnnouncer.SpellIDs[ClassCooldownAnnouncer.spellName]) then cooldown = GetSpellCooldown(ClassCooldownAnnouncer.SpellIDs[ClassCooldownAnnouncer.spellName], BOOKTYPE_SPELL); end
		
		
		if (cooldown==0 and spellName==string.lower(ClassCooldownAnnouncer.spellName) and ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.spellName]) then
			ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.spellName] (ClassCooldownAnnouncer.spellFail, spellTargetName);
		end
		
		ClassCooldownAnnouncer.spellFail = nil;
		
	end
end

ClassCooldownAnnouncer.SpellByAction = function(spellSlot, spellTarget)

	if (ClassCooldownAnnouncer.spellFail and not ClassCooldownAnnouncer.waitingForSuccess) then

		
		local spellName
		local actionType, actionId, actionSubtype = GetActionInfo(spellSlot);
		if (actionType == "spell") then

			spellName = GetSpellName(actionId, actionType);
		end
		
		local spellTargetName = UnitName("target");
		if (spellTarget) then spellTargetName = UnitName(spellTarget); end
		
		local cooldown = GetActionCooldown(spellSlot);
		
		
		if (cooldown==0 and spellName==ClassCooldownAnnouncer.spellName and ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.spellName]) then
			ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.spellName](ClassCooldownAnnouncer.spellFail, spellTargetName);
		end
	
		ClassCooldownAnnouncer.spellFail = nil;
	end
end

ClassCooldownAnnouncer.SpellById = function(spellId, spellType)

	if (ClassCooldownAnnouncer.spellFail and not ClassCooldownAnnouncer.waitingForSuccess) then

		
		local spellName = GetSpellName(spellId, spellType);
		local spellTargetName = UnitName("target");
		local cooldown = GetSpellCooldown(spellID, spellType);
				

		if (cooldown==0 and spellName==ClassCooldownAnnouncer.spellName and ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.spellName]) then
			ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.spellName](ClassCooldownAnnouncer.spellFail, spellTargetName);
		end
		
		ClassCooldownAnnouncer.spellFail = nil;
	end
end

ClassCooldownAnnouncer.SpellByNameHook = ClassCooldownAnnouncer.SpellByName;
ClassCooldownAnnouncer.SpellByActionHook = ClassCooldownAnnouncer.SpellByAction;
ClassCooldownAnnouncer.SpellByIdHook = ClassCooldownAnnouncer.SpellById;

hooksecurefunc("CastSpellByName", ClassCooldownAnnouncer.SpellByNameHook);
hooksecurefunc("CastSpell", ClassCooldownAnnouncer.SpellByIdHook);
hooksecurefunc("UseAction", ClassCooldownAnnouncer.SpellByActionHook);




-- Output Functions --


ClassCooldownAnnouncer.ChatPrint = function(msg)
	if ( DEFAULT_CHAT_FRAME ) then
		if (type(msg)=="string" or type(msg)=="number") then
			DEFAULT_CHAT_FRAME:AddMessage("<ClassCooldownAnnouncer> "..msg, 1, 0.8, 0);
		end
	end
end

ClassCooldownAnnouncer.ChatMessage = function (msg, chatType, channel)

		SendChatMessage(msg, chatType, nil, channel);
	
end




-- Internal Functions --


ClassCooldownAnnouncer.GetSpellID = function(spellName)
	local i=1;
	local spell;
	
	while true do
		spellName = GetSpellBookItemName(i, BOOKTYPE_SPELL);
		if not spell then
			break;
		end
		
		if (string.lower(spell) == string.lower(spellName)) then
			return i;
		end
		
		i = i+1;
	end
	--return nil;
end

ClassCooldownAnnouncer.SpellIDs = {};
for spellName in pairs(ClassCooldownAnnouncer.Announces) do
	ClassCooldownAnnouncer.SpellIDs[spellName] = ClassCooldownAnnouncer.GetSpellID(spellName);
end


ClassCooldownAnnouncer.RegisterEvents = function(enable)

	if (enable==nil) then enable = true; end
	ClassCooldownAnnouncer.enabled = enable;
		
	if (ClassCooldownAnnouncer.enabled) then
		
		ClassCooldownAnnouncer.SpellByNameHook = ClassCooldownAnnouncer.SpellByName;
		ClassCooldownAnnouncer.SpellByActionHook = ClassCooldownAnnouncer.SpellByAction;
		ClassCooldownAnnouncer.SpellByIdHook = ClassCooldownAnnouncer.SpellById;
	
		ClassCooldownAnnouncer.frame:RegisterEvent("UNIT_SPELLCAST_SENT");
		
		ClassCooldownAnnouncer.frame:RegisterEvent("UNIT_SPELLCAST_START");
		ClassCooldownAnnouncer.frame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
		
		--ClassCooldownAnnouncer.frame:RegisterEvent("UI_ERROR_MESSAGE");
		ClassCooldownAnnouncer.frame:RegisterEvent("UNIT_SPELLCAST_FAILED");
		ClassCooldownAnnouncer.frame:RegisterEvent("CHAT_MSG_SPELL_FAILED_LOCALPLAYER");
	
		ClassCooldownAnnouncer.ChatPrint("ClassCooldownAnnouncer |cff00ff00activated|r.");
	else
		--clean any running errors.
		ClassCooldownAnnouncer.spellFail = nil;
		
		ClassCooldownAnnouncer.SpellByNameHook = nil
		ClassCooldownAnnouncer.SpellByActionHook = nil;
		ClassCooldownAnnouncer.SpellByIdHook = nil;
		
		ClassCooldownAnnouncer.frame:UnregisterAllEvents();
		
		ClassCooldownAnnouncer.ChatPrint("ClassCooldownAnnouncer |cffff0000inactive|r.");
	end
end

ClassCooldownAnnouncer.RegisterEvents(ClassCooldownAnnouncer.enabled);
