-- This file is supposed to be edited by the user.
-- Just follow the instructions and comments and you'll see its just an easy way to go to setup your own spells and announces!


ClassCooldownAnnouncer.enabled = true;	--  ClassCooldownAnnouncer will be active at startup


	-- Announce functions for each spell ---
-- Here you can add additional spells or  messages to specific channel for example --



-- Instruction to easily add a spell without localizaton:


--ClassCooldownAnnouncer.Announces["SpellName"] = function(success, target)
--	if (success == "success") then
--		ClassCooldownAnnouncer.ChatMessage("SpellName on you!", "WHISPER", target);
--
--	end
--end

--  There is also the possibility to announce the messages in other channels. For example your Healer Channel or Raid Channel:
-- 	Just add or replace the old code with this code and you would announce "SpellName on: PlayerName" in Channel 5:
--  DruidAnnounces.ChatMessage("SpellName on: "..target, "CHANNEL", 5);

-- If you want to announce it in a Raid or Party Channel you have to use this code:

-- local channel = "SAY";
-- if (GetNumPartyMembers()>0) then channel = "PARTY"; end
-- if (GetNumRaidMembers()>0) then channel = "RAID"; end
-- ClassCooldownAnnouncer.ChatMessage("SpellName on: "..target, channel, nil);

-- This code sets your local channel on "Say-Chat". If you're not in a Raid or Party you will announce it in "Say".
-- Then it checks for if you're in a party or in a raid and choses its channel.
-- On the last part it will send the Announce: "SpellName on: PlayerName" in Say, Raid, or Party Channel. Depends on which kind it detected.

-- You could also only use "DruidAnnounces.ChatMessage("SpellName on: "..target, "RAID", 5);", 
-- but with this code you would always get a "You are not in Raid" message if you use this spell out of a raid.

-- If you dont't want to have any announces for any spell already implemented, just comment it out with "--".

-- DRUID --

-- Innervate announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.INNERVATE_NAME] = function(success, target)
	if (success == "success") then
	
		--local channel = "SAY";
		--if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		--if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.INNERVATE_SUCCESS, "WHISPER", target);
		--ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.INNERVATECHANNEL_SUCCESS..target, channel, nil);
	
	-- only announces Innervate per whisper. If you want to announce it in party or raid chat, just remove the "--"
	
	end
end


-- Rebirth announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.COMBATRES_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.COMBATRES_SUCCESS..target, channel);
		
	end
end

-- Tranquility announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.TRANQ_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.TRANQ_SUCCESS, channel, nil);

	end
end

-- Survival Instincts announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.INSTINCTS_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.INSTINCTS_SUCCESS, channel, nil);

	end
end

-- Frenzied Regeneration announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.REGENERATION_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.REGENERATION_SUCCESS, channel, nil);

	end
end


-- DEATH KNIGHT --

-- Raise Ally announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.RAISEALLY_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.RAISEALLY_SUCCESS..target, channel);

	end
end

-- Unholy Frenzy announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.FRENZY_NAME] = function(success, target)
	if (success == "success") then
		
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.FRENZY_SUCCESS, "WHISPER", target);

	end
end

-- Vampiric Blood announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.BLOOD_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.BLOOD_SUCCESS, channel, nil);

	end
end

-- Icebound Fortitude announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.ICEBOUND_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.ICEBOUND_SUCCESS, channel, nil);

	end
end

-- Anti Magic Zone announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.MAGICZONE_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.MAGICZONE_SUCCESS, channel, nil);

	end
end


-- WARLOCK --

-- Soulstone announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.SOULSTONE_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.SOULSTONE_SUCCESS..target, channel);
	
	end
end

-- Dark Intent announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.DARKINTENT_NAME] = function(success, target)
	if (success == "success") then
		
		--local channel = "SAY";
		--if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		--if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.DARKINTENT_SUCCESS, "WHISPER", target);
		--ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.DARKINTENTCHANNEL_SUCCESS..target, channel, nil);
		
	end
end


-- PRIEST --

-- Power Infusion announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.POWERINFUSION_NAME] = function(success, target)
	if (success == "success") then

		--local channel = "SAY";
		--if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		--if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.POWERINFUSION_SUCCESS, "WHISPER", target);
		--ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.POWERINFUSIONCHANNEL_SUCCESS..target, channel, nil);
		
	end
end

-- Pain Suppression announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.PAINSUP_NAME] = function(success, target)
	if (success == "success") then

		--local channel = "SAY";
		--if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		--if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.PAINSUP_SUCCESS, "WHISPER", target);
		--ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.PAINSUPCHANNEL_SUCCESS..target, channel, nil);
				
	end
end

-- Guardian Spirit announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.SPIRIT_NAME] = function(success, target)
	if (success == "success") then

		--local channel = "SAY";
		--if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		--if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.SPIRIT_SUCCESS, "WHISPER", target);
		--ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.SPIRITCHANNEL_SUCCESS..target, channel, nil);
		
	end
end

-- Power Word: Barrier announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.BARRIER_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.BARRIER_SUCCESS, channel, nil);

	end
end

-- Hymn of Hope announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.HOPE_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.HOPE_SUCCESS, channel, nil);

	end
end

-- Divine Hymn announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.DIVINE_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.DIVINE_SUCCESS, channel, nil);

	end
end


-- HUNTER --

-- Ancient Hysteria announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.ANCIENT_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.ANCIENT_SUCCESS, channel, nil);

	end
end


-- MAGE --

-- Time Warp announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.WARP_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.WARP_SUCCESS, channel, nil);

	end
end

-- Focus Magic announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.FOCUS_NAME] = function(success, target)
	if (success == "success") then
		
		--local channel = "SAY";
		--if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		--if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.FOCUS_SUCCESS, "WHISPER", target);
		--ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.FOCUSCHANNEL_SUCCESS..target, channel, nil);
		
	end
end

-- SHAMAN --

-- Heroism announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.HEROISM_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.HEROISM_SUCCESS, channel, nil);

	end
end

-- Bloodlust announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.BLOODLUST_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.BLOODLUST_SUCCESS, channel, nil);

	end
end

-- Spirit Link Totem announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.SPIRITLINK_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.SPIRITLINK_SUCCESS, channel, nil);

	end
end


-- PALADIN --

-- Divine Guardian announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.DIVGUARD_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.DIVGUARD_SUCCESS, channel, nil);

	end
end

-- Artend Defender announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.ARDENT_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.ARDENT_SUCCESS, channel, nil);

	end
end


-- ROGUE --

-- Tricks of the Trade announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.TRICKS_NAME] = function(success, target)
	if (success == "success") then
		
		--local channel = "SAY";
		--if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		--if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.TRICKS_SUCCESS, "WHISPER", target);
		--ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.TRICKSCHANNEL_SUCCESS..target, channel, nil);
		
	end
end


-- WARRIOR --

-- Shield Wall announces
ClassCooldownAnnouncer.Announces[ClassCooldownAnnouncer.WALL_NAME] = function(success, target)
	if (success=="success") then

		local channel = "SAY";
		if (GetNumPartyMembers()>0) then channel = "PARTY"; end
		if (GetNumRaidMembers()>0) then channel = "RAID"; end
		ClassCooldownAnnouncer.ChatMessage(ClassCooldownAnnouncer.WALL_SUCCESS, channel, nil);

	end
end
